'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _style = require('./style.css');

var _style2 = _interopRequireDefault(_style);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SideLink = function SideLink(props) {
  var clz = (0, _classnames2.default)(_style2.default.side, (0, _defineProperty3.default)({}, _style2.default.hide, props.hide));
  return _react2.default.createElement(
    'li',
    { className: clz },
    _react2.default.createElement(
      'a',
      { href: '#', onClick: props.onClick },
      props.children
    )
  );
};

var Link = function Link(props) {
  var clz = (0, _classnames2.default)((0, _defineProperty3.default)({}, _style2.default.active, props.active));
  return _react2.default.createElement(
    'li',
    { className: clz },
    _react2.default.createElement(
      'a',
      { href: '#', onClick: props.onClick },
      props.children
    )
  );
};

var Dots = function Dots() {
  return _react2.default.createElement(
    'li',
    { className: _style2.default.dots },
    '...'
  );
};

var Pager = function (_Component) {
  (0, _inherits3.default)(Pager, _Component);

  function Pager(props) {
    (0, _classCallCheck3.default)(this, Pager);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Pager).call(this, props));

    _this.state = {
      curpage: props.curpage
    };
    return _this;
  }

  (0, _createClass3.default)(Pager, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      var count = Math.ceil(props.total / props.perpage);
      var curpage = props.curpage > count ? 1 : props.curpage;
      this.setState({
        curpage: curpage
      });
    }
  }, {
    key: 'prev',
    value: function prev(curr) {
      if (curr === 1) return;
      this.active(this.state.curpage - 1);
    }
  }, {
    key: 'next',
    value: function next(curr, count) {
      if (curr === count) return;
      this.active(this.state.curpage + 1);
    }
  }, {
    key: 'getPageCount',
    value: function getPageCount() {
      var props = this.props;
      return Math.ceil(props.total / props.perpage);
    }
  }, {
    key: 'getLinks',
    value: function getLinks(count) {
      var _this2 = this;

      var res = [];
      var curpage = this.state.curpage;
      var limit = this.props.limit;
      if (curpage > limit - 2 && curpage < count - 1) {
        limit = curpage + 2;
      }

      var _loop = function _loop(i) {
        var active = curpage == i;
        if (i === limit - 1) {
          res.push(_react2.default.createElement(Dots, { key: i }));
        } else if (i > limit - 1 && i < count - 1) {
          return 'continue';
        } else {
          res.push(_react2.default.createElement(
            Link,
            { key: i, onClick: function onClick() {
                _this2.active(i);
              }, active: active },
            i
          ));
        }
      };

      for (var i = 1; i <= count; i++) {
        var _ret = _loop(i);

        if (_ret === 'continue') continue;
      }
      return res;
    }
  }, {
    key: 'active',
    value: function active(i) {
      if (this.state.curpage == i) return;
      this.setState({ curpage: i });
      this.props.onChange(i);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      if (props.total == 0) {
        return null;
      } else {
        var curr = this.state.curpage;
        var count = this.getPageCount();
        var hidePrev = curr == 1;
        var hideNext = curr == count;
        var links = this.getLinks(count);
        return _react2.default.createElement(
          'ul',
          { className: (0, _classnames2.default)(_style2.default.pager, props.className), style: props.style },
          _react2.default.createElement(
            SideLink,
            { hide: hidePrev, onClick: this.prev.bind(this, curr) },
            '‹'
          ),
          links,
          _react2.default.createElement(
            SideLink,
            { hide: hideNext, onClick: this.next.bind(this, curr, count) },
            '›'
          )
        );
      }
    }
  }]);
  return Pager;
}(_react.Component);

Pager.defaultProps = {
  limit: Infinity,
  curpage: 1
};
Pager.propTypes = {
  curpage: _propTypes2.default.number.isRequired,
  perpage: _propTypes2.default.number.isRequired,
  total: _propTypes2.default.number.isRequired,
  limit: _propTypes2.default.number,
  onChange: _propTypes2.default.func.isRequired
};
exports.default = Pager;